
//
//	HSP3 graphics command
//	(GUI֘AR}hE֐)
//	onion software/onitama 2004/6
//
#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <nds.h>
#include <nds/registers_alt.h>

#include "as_lib9.h"
#include "hsp3config.h"
#include "hsp3code.h"
#include "hsp3debug.h"
#include "supio.h"
#include "strbuf.h"

#include "hsp3gr_nds.h"
#include "nds_console.h"
#include "dpmread.h"

// type def
struct Sprite {
	int id;
	int used;
	unsigned int lastUsed;
};

/*------------------------------------------------------------*/
/*
		system data
*/
/*------------------------------------------------------------*/
static const int MAX_SPRITE = 1024;
static const int MAX_MAP = 1024;
static const int MAX_MAP_ID = 4096;
static const int MAX_SOUND = 16;

static HSPCTX *ctx;
static int *type;
static int *val;
static int cur_window;
static int p1,p2,p3,p4,p5,p6;
static int ckey,cklast,cktrg;
static int msact;
static int dispflg;

static int spriteSize;
static int spriteShape;
static int tilesPerSprite;
static SpriteEntry spriteEntry[128];
static SpriteRotation *spriteRotation;
static u16* spriteTiles;
static Sprite sprites[MAX_SPRITE];
static u16* mapTiles;
static Sprite maps[MAX_MAP * 2];
static u16 mapId[MAX_MAP_ID * 2];
static u16 bgMap[64 * 64 * 2];
static bool bg2Visible = false;
static bool bg3Visible = false;
static SoundInfo sounds[MAX_SOUND];

extern int resY0, resY1;
extern unsigned int GetTickCount();

void loadSprite( char* filename, int mode );
int useSprite( int id );
void releaseSprite( int id );

void loadTile( char* filename );
int useTile( int id, int no );
void releaseTile( int id, int no );
/*----------------------------------------------------------*/
//					HSP system support
/*----------------------------------------------------------*/
PDAT *HspVarCoreArrayElementPtr( PVal *pval, APTR idx0 )
{
	int offset = 0;
	int arraycnt = 0;
	int arraymul = 0;

	if ( idx0 < 0 ) throw HSPVAR_ERROR_ARRAYOVER;

	if ( arraycnt == 0 ) {
		arraymul = 1;
	} else {
		arraymul *= pval->len[ arraycnt ];
	}
	arraycnt++;
	if ( idx0 >= (pval->len[ arraycnt ]) ) {
		throw HSPVAR_ERROR_ARRAYOVER;
	}

	offset += idx0 * arraymul;

	pval->offset = offset;
	return hspvarproc[(pval)->flag].GetPtr(pval);
}

PDAT *HspVarCoreArrayElementPtr( PVal *pval, APTR idx0, APTR idx1 )
{
	int offset = 0;
	int arraycnt = 0;
	int arraymul = 0;

	if ( idx0 < 0 || idx1 < 0 ) {
		printf("error1\n");
		throw HSPVAR_ERROR_ARRAYOVER;
	}

	if ( arraycnt == 0 ) {// 0
		arraymul = 1;
	} else {
		arraymul *= pval->len[ arraycnt ];
	}
	arraycnt++;
	if ( idx0 >= (pval->len[ arraycnt ]) ) {
		printf("error2 %d %d %d\n", idx0, pval->len[ arraycnt ], arraycnt);
		throw HSPVAR_ERROR_ARRAYOVER;
	}

	offset += idx0 * arraymul;


	if ( arraycnt == 0 ) {// 1
		arraymul = 1;
	} else {
		arraymul *= pval->len[ arraycnt ];
	}
	arraycnt++;
	if ( idx1 >= (pval->len[ arraycnt ]) ) {
		printf("error3\n");
		throw HSPVAR_ERROR_ARRAYOVER;
	}

	offset += idx1 * arraymul;

	pval->offset = offset;
	//printf("%d %d [%d %x %d]\n", pval->len[1], pval->len[2], offset, hspvarproc[(pval)->flag].GetPtr(pval), *(int*)hspvarproc[(pval)->flag].GetPtr(pval));
	return hspvarproc[(pval)->flag].GetPtr(pval);
}

PDAT *HspVarCoreArrayElementPtr( PVal *pval, APTR idx0, APTR idx1, APTR idx2 )
{
	int offset = 0;
	int arraycnt = 0;
	int arraymul = 0;

	if ( idx0 < 0 || idx1 < 0 || idx2 < 0 ) throw HSPVAR_ERROR_ARRAYOVER;

	if ( arraycnt == 0 ) {// 0
		arraymul = 1;
	} else {
		arraymul *= pval->len[ arraycnt ];
	}
	arraycnt++;
	if ( idx0 >= (pval->len[ arraycnt ]) ) {
		throw HSPVAR_ERROR_ARRAYOVER;
	}

	offset += idx0 * arraymul;


	if ( arraycnt == 0 ) {// 1
		arraymul = 1;
	} else {
		arraymul *= pval->len[ arraycnt ];
	}
	arraycnt++;
	if ( idx1 >= (pval->len[ arraycnt ]) ) {
		throw HSPVAR_ERROR_ARRAYOVER;
	}

	offset += idx1 * arraymul;


	if ( arraycnt == 0 ) {// 2
		arraymul = 1;
	} else {
		arraymul *= pval->len[ arraycnt ];
	}
	arraycnt++;
	if ( idx2 >= (pval->len[ arraycnt ]) ) {
		throw HSPVAR_ERROR_ARRAYOVER;
	}

	offset += idx2 * arraymul;

	pval->offset = offset;
	return hspvarproc[(pval)->flag].GetPtr(pval);
}


static void ExecFile( char *stmp, char *ps, int mode )
{
	//	Ot@Cs
}
		
static char *getdir( int id )
{
	//		dirinfo߂̓estmpɐݒ肷
	//
	char *p;
	char *ss;
	char fname[HSP_MAX_PATH+1];
	p = ctx->stmp;

	*p = 0;

	switch( id ) {
	case 0:				//    Jg(݂)fBNg
		break;
	case 1:				//    HSP̎st@CfBNg
		break;
	case 2:				//    WindowsfBNg
		break;
	case 3:				//    Windows̃VXefBNg
		break;
	case 4:				//    R}hC
		break;
	default:
		throw HSPERR_ILLEGAL_FUNCTION;
	}

	return p;
}


static int sysinfo( int p2 )
{
	//		System strings get
	//
	int fl;
	char *p1;

	fl = HSPVAR_FLAG_INT;
	p1 = ctx->stmp;
	*p1 = 0;

	return fl;
}


void *ex_getbmscr( int wid )
{
	return NULL;
}

void ex_mref( PVal *pval, int prm )
{
	int t,size;
	void *ptr;
	const int GETBM=0x60;
	t = HSPVAR_FLAG_INT;
	size = 4;
	if ( prm >= GETBM ) {
		throw HSPERR_UNSUPPORTED_FUNCTION;
	} else {
		switch( prm ) {
		case 0x40:
			ptr = &ctx->stat;
			break;
		case 0x41:
			ptr = ctx->refstr;
			t = HSPVAR_FLAG_STR;
			size = 1024;
			break;
		case 0x44:
			ptr = ctx; size = sizeof(HSPCTX);
			break;
		default:
			throw HSPERR_UNSUPPORTED_FUNCTION;
		}
	}
	HspVarCoreDupPtr( pval, t, ptr, size );
}


/*------------------------------------------------------------*/
/*
		interface
*/
/*------------------------------------------------------------*/

static void cmdfunc_dialog( void )
{
	// dialog
	int i;
	char *ptr;
	char *ps;
	char stmp[0x4000];
	ptr = code_getdsi( "" );
	strncpy( stmp, ptr, 0x4000-1 );
	p1 = code_getdi( 0 );
	ps = code_getds("");

}


static int cmdfunc_extcmd( int cmd )
{
	//		cmdfunc : TYPE_EXTCMD
	//		(GUIR}h)
	//
	code_next();							// ̃R[h擾(ŏɕKKvł)
	switch( cmd ) {							// TuR}hƂ̕

	case 0x02:								// exec
		{
		char *ps;
		char fname[HSP_MAX_PATH];
		strncpy( fname, code_gets(), HSP_MAX_PATH-1 );
		p1 = code_getdi( 0 );
		ps = code_getds( "" );
		ExecFile( fname, ps, p1 );
		break;
		}

	case 0x03:								// dialog
		cmdfunc_dialog();
		break;

	case 0x0f:								// mes,print
		{
		//char stmp[1024];
		char *ptr;
		int chk;
		chk = code_get();
		if ( chk<=PARAM_END ) {
			printf( "\n" );
			break;
		}
		ptr = (char *)(HspVarCorePtr(mpval));
		if ( mpval->flag != HSPVAR_FLAG_STR ) {
			ptr = (char *)HspVarCoreCnv( mpval->flag, HSPVAR_FLAG_STR, ptr );	// ^vȂꍇ͕ϊ
		}
		printf( "%s\n",ptr );
		//strsp_ini();
		//while(1) {
		//	chk = strsp_get( ptr, stmp, 0, 1022 );
		//	printf( "%s\n",stmp );
		//	if ( chk == 0 ) break;
		//}
		break;
		}

	case 0x40:								// ndsMes
	{
		//char stmp[1024];
		char *ptr;
		int chk;
		chk = code_get();

		if ( chk<=PARAM_END ) {
			printf( "\n" );
			break;
		}
		ptr = (char *)(HspVarCorePtr(mpval));
		if ( mpval->flag != HSPVAR_FLAG_STR ) {
			ptr = (char *)HspVarCoreCnv( mpval->flag, HSPVAR_FLAG_STR, ptr );	// ^vȂꍇ͕ϊ
		}
		printf( "%s",ptr );
		break;
	}

	case 0x41:								// ndsPos
	{
		p1 = code_getdi( 0 );
		p2 = code_getdi( 0 );

		if (p1 >= 0 && p1 < CONSOLE_WIDTH && p2 >= 0 && p2 < CONSOLE_HEIGHT)
			printf( "\x1b[%d;%df", p2, p1 );
		break;
	}

	case 0x42:								// ndsCls
	{
		printf( "\x1b[2J" );
		break;
	}

	case 0x43:								// ndsCll
	{
		printf( "\x1b[2K" );
		break;
	}

	case 0x45:								// ndsSwap
	{
		lcdSwap();
		break;
	}

	case 0x50:								// ndsKey
	{
	    PVal *pdown, * pheld;
		int down;
		int held;

		p1 = code_getva( &pdown );
		p2 = code_getva( &pheld );

		scanKeys();

		down = keysDown();
		held = keysHeld();
		
		code_setva( pdown, p1, TYPE_INUM, &down );
		code_setva( pheld, p2, TYPE_INUM, &held );
		break;
	}

	case 0x51:								// ndsTouch
	{
		touchPosition touch;
	    PVal *px, *py, *ppx, *ppy;

		p1 = code_getva( &px );
		p2 = code_getva( &py );
		p3 = code_getva( &ppx );
		p4 = code_getva( &ppy );
		
		touch = touchReadXY();

		int tx = touch.x;
		int ty = touch.y;
		int tpx = touch.px;
		int tpy = touch.py;
		
		code_setva( px, p1, TYPE_INUM, &tx );
		code_setva( py, p2, TYPE_INUM, &ty );
		code_setva( ppx, p3, TYPE_INUM, &tpx );
		code_setva( ppy, p4, TYPE_INUM, &tpy );
		break;
	}

	case 0x60:								// ndsSprLoad
	{
		char *ptr = code_gets();
		p1 = code_getdi( 0 );
		
		loadSprite( ptr, p1 );
		break;
	}

	case 0x61:								// ndsSprMove
	{
		int index = code_getdi( 0 );
		int mode = code_getdi( 0 );
		int id = code_getdi( 0 );
		int x = code_getdi( 0 );
		int y = code_getdi( 0 );
		int priority = code_getdi( 0 );
		int tile = 0;
		
		if (index < 0 || index > 127)
			throw HSPERR_INVALID_PARAMETER;
		
		bool show = mode != ATTR0_DISABLED;
		bool hidden = !spriteEntry[index].isRotoscale && spriteEntry[index].isHidden;
		if (!hidden) {
			releaseSprite(spriteEntry[index].tileIdx);
		}

		if (show) {
			tile = useSprite( id ); 
			if (tile < 0) {
				tile = 0;
				mode = ATTR0_DISABLED;
			}
		}
	
		spriteEntry[index].attribute[0] = spriteShape | ATTR0_COLOR_256 | mode |  OBJ_Y(y);
		spriteEntry[index].attribute[1] = spriteSize | OBJ_X(x);
		spriteEntry[index].attribute[2] = tilesPerSprite * tile | ATTR2_PRIORITY(priority & 3);		
		break;
	}

	case 0x62:								// ndsSprUpdate
	{
		DC_FlushRange(spriteEntry,128 * sizeof(SpriteEntry));
		dmaCopy(spriteEntry, OAM, 128 * sizeof(SpriteEntry));

		int endTile = MAX_SPRITE / tilesPerSprite;
		int used = 0;
		for (int i = 0; i < endTile; i++) {
			if (sprites[i].id >= 0) {
				used++;
			}
		}
		//printf(">>>>>>>>>>>>> %d / %d\n", used, endTile);
		break;
	}

	case 0x68:								// ndsTileSetState
	{
		int no = code_getdi( 0 );
		int visible = code_getdi( 0 );
		int pr = code_getdi( 0 );

		int cr = BG_64x64 | BG_COLOR_256 | BG_PRIORITY(pr & 3);
		switch (no) {
		case 0:
			BG3_CR = cr | BG_MAP_BASE(0) | BG_TILE_BASE(1);
			bg3Visible = visible;
			break;
		case 1:
			BG2_CR = cr | BG_MAP_BASE(3) | BG_TILE_BASE(5);
			bg2Visible = visible;
			break;
		}
		videoSetMode(MODE_0_2D
					 | (bg2Visible ? DISPLAY_BG2_ACTIVE : 0)
					 | (bg3Visible ? DISPLAY_BG3_ACTIVE : 0)
					 | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D | DISPLAY_SPR_1D_BMP);
		break;
	}

	case 0x69:								// ndsTileLoad
	{
		char *ptr = code_gets();
		
		loadTile( ptr );
		break;
	}

	case 0x6a:								// ndsTileSetMap
	{
		PVal *pval;
		PDAT *p;
		int no = code_getdi( 0 );
		pval = code_getpval();

		if ( pval->flag != HSPVAR_FLAG_INT ) {
			throw HSPERR_TYPE_MISMATCH;
		}

		int ofs = (no * 64 * 64);

		u16* map;
		if (no == 0)
			map = (u16*)BG_MAP_RAM(0);
		else
			map = (u16*)BG_MAP_RAM(3);

		for ( int hy = 0; hy < 2; hy++ ) {
			for ( int hx = 0; hx < 2; hx ++) {
				int idxofs = (hx + hy * 2) * 32 * 32;

				for ( int ly = 0; ly < 32; ly++ ) {
					int y = (hy << 5) + ly;
					for ( int lx = 0; lx < 32; lx++ ) {
						int x = (hx << 5) + lx;
						int idx = idxofs + ((ly << 5) + lx);
						int id = *(int*)HspVarCoreArrayElementPtr( pval, x, y );
						int n = useTile(id, no);
						int cur = bgMap[idx + ofs];

						//printf("%d ", id);
						//printf("%d %d=%d(%d) %d %d %d %d\n", x, y, id, idx, lx, hx, ly, hy);
						if ( cur != n ) {
							if ( cur != 0xffff) {
								releaseTile( cur, no );
							}
							
							if (n >= 0) {
								//printf("      %d %d=%d(%d)\n", x, y, id, n);
								bgMap[idx + ofs] = n;
								map[idx] = n;
							} else {
								printf("no more tile space\n");
							}
						}
					}
				}
			}
			//printf("\n");
		}
		break;
	}

	case 0x6b:								// ndsTileMove
	{
		int no = code_getdi( 0 );
		int x = code_getdi( 0 );
		int y = code_getdi( 0 );

		switch (no) {
		case 0:
			BG3_X0 = x;
			BG3_Y0 = y;
			break;
		case 1:
			BG2_X0 = x;
			BG2_Y0 = y;
			break;
		}
		break;
	}

	case 0x70:								// ndsSndLoad
	{
		int id = code_getdi(0);
		char *ptr = code_gets();
		int format = code_getdi(AS_PCM_8BIT);
		int rate = code_getdi(11025);
		int volume = code_getdi(127);
		int pan = code_getdi(64);
		int loop = code_getdi(0);
		int priority = code_getdi(0);
		SoundInfo *snd = sounds + id;

		if (id < 0 || id >= MAX_SOUND) break;
		if (snd->data != NULL) free(snd->data);

		snd->size = dpm_exist( ptr );
		if ( snd->size < 0 ) return NULL;
		snd->data = (u8*)memalign( 4, snd->size );//mem_ini( snd->size );
		int res = dpm_read( ptr, snd->data, snd->size, 0 );
		snd->format = format;
		snd->rate = rate;
		snd->volume = volume;
		snd->pan = pan;
		snd->loop = loop;
		snd->priority = priority;
		break;
	}

	case 0x71:								// ndsSndPlay
	{
		int id = code_getdi(0);
		SoundInfo *snd = sounds + id;
		if (id < 0 || id >= MAX_SOUND) break;
		if (snd->data == NULL) break;
		AS_SoundPlay(*snd);
		break;
	}

	case 0x80:								// ndsMp3Play
	{
		char *ptr = code_gets();
		AS_MP3StreamPlay(ptr);
		/*
		while (1) {
			iprintf("\x1b[19;0HMP3 Status : ");    // clear status field
			switch (AS_GetMP3Status()) {
			case (MP3ST_STOPPED) :      iprintf("stopped       "); break;
			case (MP3ST_PAUSED) :       iprintf("paused        "); break;
			case (MP3ST_PLAYING) :      iprintf("playing       "); break;
			case (MP3ST_OUT_OF_DATA) :  iprintf("out of data   "); break;
			case (MP3ST_DECODE_ERROR) : iprintf("decoding error"); break;
			}
		  swiWaitForVBlank();
		}
		*/
		break;
	}

	case 0x81:								// ndsMp3Pause
	{
		AS_MP3Pause();
		break;
	}

	case 0x82:								// ndsMp3Unpause
	{
		AS_MP3Unpause();
		break;
	}

	case 0x83:								// ndsMp3Stop
	{
		AS_MP3Stop();
		break;
	}

	case 0x84:								// ndsMp3Volume
	{
		p1 = code_getdi( 0 );
		AS_SetMP3Volume(p1);
		break;
	}

	case 0x85:								// ndsMp3Pan
	{
		p1 = code_getdi( 0 );
		AS_SetMP3Pan(p1);
		break;
	}

	case 0x86:								// ndsMp3Loop
	{
		p1 = code_getdi( 0 );
		AS_SetMP3Loop(p1);
		break;
	}

	default:
		throw HSPERR_UNSUPPORTED_FUNCTION;
	}
	return RUNMODE_RUN;
}


static int reffunc_intfunc_ivalue;

static void *reffunc_function( int *type_res, int arg )
{
	void *ptr;

	//		Ԓl̃^Cvݒ肷
	//
	*type_res = HSPVAR_FLAG_INT;			// Ԓl̃^Cvw肷
	ptr = &reffunc_intfunc_ivalue;			// Ԓl̃|C^

	//			'('Ŏn܂邩𒲂ׂ
	//
	if ( *type != TYPE_MARK ) throw HSPERR_INVALID_FUNCPARAM;
	if ( *val != '(' ) throw HSPERR_INVALID_FUNCPARAM;
	code_next();

	switch( arg & 0xff ) {

	//	int function

	case 0x002:								// dirinfo
		p1 = code_geti();
		ptr = getdir( p1 );
		*type_res = HSPVAR_FLAG_STR;
		break;

	case 0x003:								// sysinfo
		p1 = code_geti();
		*type_res = sysinfo( p1 );
		ptr = ctx->stmp;
		break;

	default:
		throw HSPERR_UNSUPPORTED_FUNCTION;
	}

	//			'('ŏI邩𒲂ׂ
	//
	if ( *type != TYPE_MARK ) throw HSPERR_INVALID_FUNCPARAM;
	if ( *val != ')' ) throw HSPERR_INVALID_FUNCPARAM;
	code_next();

	return ptr;
}


static int termfunc_extcmd( int option )
{
	//		termfunc : TYPE_EXTCMD
	//		(GUI)
	//
	return 0;
}

void hsp3typeinit_cl_extcmd( HSP3TYPEINFO *info )
{
	HSPEXINFO *exinfo;								// Info for Plugins
	int i;

	ctx = info->hspctx;
	exinfo = info->hspexinfo;
	type = exinfo->nptype;
	val = exinfo->npval;

	//		function register
	//
	info->cmdfunc = cmdfunc_extcmd;
	info->termfunc = termfunc_extcmd;

	//		HSPEXINFOɊ֐o^
	//
	exinfo->actscr = &cur_window;					// Active Window ID
	exinfo->HspFunc_getbmscr = ex_getbmscr;
	exinfo->HspFunc_mref = ex_mref;

	//		oCi[hݒ
	//
	//_setmode( _fileno(stdin),  _O_BINARY );

	// XvCg̐ݒ
	spriteRotation = (SpriteRotation*)spriteEntry;

	for (i = 0; i < 128; i++) {
		spriteEntry[i].attribute[0] = ATTR0_DISABLED;
		spriteEntry[i].attribute[1] = 0;
		spriteEntry[i].attribute[2] = 0;
	}
	
	for (i = 0; i < 32; i++) {
		spriteRotation[i].hdx = 256;
		spriteRotation[i].hdy = 0;
		spriteRotation[i].vdx = 0;
		spriteRotation[i].vdy = 256;
	}

	for (i = 0; i < MAX_SPRITE; i++) {
		sprites[i].id = -1;
		sprites[i].used = 0;
		sprites[i].lastUsed = 0;
	}

	for (i = 0; i < MAX_MAP * 2; i++) {
		maps[i].id = -1;
		maps[i].used = 0;
		maps[i].lastUsed = 0;
	}

	for (i = 0; i < 64 * 64 * 2; i++) {
		bgMap[i] = (u16)0xffff;
	}

	for (i = 0; i < MAX_MAP_ID * 2; i++) {
		mapId[i] = (u16)0xffff;
	}

	for (i = 0; i < MAX_SOUND; i++) {
		sounds[i].data = NULL;
	}

	//loadTile("town01_a.bmp");
}

typedef struct tagBITMAPFILEHEADER {
  unsigned short bfType;
  unsigned long  bfSize;
  unsigned short bfReserved1;
  unsigned short bfReserved2;
  unsigned long  bfOffBits;
}__attribute__ ((packed)) BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER{
    unsigned long  biSize;
    long           biWidth;
    long           biHeight;
    unsigned short biPlanes;
    unsigned short biBitCount;
    unsigned long  biCompression;
    unsigned long  biSizeImage;
    long           biXPixPerMeter;
    long           biYPixPerMeter;
    unsigned long  biClrUsed;
    unsigned long  biClrImporant;
} __attribute__ ((packed)) BITMAPINFOHEADER;

typedef struct tagRGBQUAD{
    unsigned char rgbBlue;
    unsigned char rgbGreen;
    unsigned char rgbRed;
    unsigned char rgbReserved;
} RGBQUAD;


#define SPRITE_MODE_8x8		0x0000
#define SPRITE_MODE_16x8	0x0100
#define SPRITE_MODE_8x16	0x0200

#define SPRITE_MODE_16x16	0x0001
#define SPRITE_MODE_32x8	0x0101
#define SPRITE_MODE_8x32	0x0201

#define SPRITE_MODE_32x32	0x0002
#define SPRITE_MODE_32x16	0x0102
#define SPRITE_MODE_16x32	0x0202

#define SPRITE_MODE_64x64	0x0003
#define SPRITE_MODE_64x32	0x0103
#define SPRITE_MODE_32x64	0x0203

u8* loadBmp( char* filename, u32& width, u32& height, u16* pallet ) {

	FILE* fp = fopen( filename, "rb" );
	if ( fp == NULL ) {
		return NULL;
	}

	BITMAPFILEHEADER fileHeader;
	BITMAPINFOHEADER infoHeader;
	RGBQUAD bmpPallet[256];
	fread ( &fileHeader, sizeof(BITMAPFILEHEADER), 1, fp );
	fread ( &infoHeader, sizeof(BITMAPINFOHEADER), 1, fp );
	if (infoHeader.biBitCount != 8) {
		fclose( fp );
		return NULL;
	}
	fread ( &bmpPallet, sizeof(RGBQUAD), 256, fp );

	// Init pallet : 8bit per element -> 5 bit
	for ( int i = 0; i < 256; i++ ) {
		pallet[i] = RGB15(bmpPallet[i].rgbRed >> 3, bmpPallet[i].rgbGreen >> 3, bmpPallet[i].rgbBlue >> 3) | (1 << 15);
	}


	height = abs(infoHeader.biHeight);
	width = infoHeader.biWidth;

	int w = width;
	if (w & 3) {
		w = ((w >> 2) + 1) << 2;
	}

	u8* data = (u8*)malloc(width * height);
	u8* raw = (u8*)malloc(w * height);
	fread ( raw, 1, w * height, fp );
	for ( int y = 0; y < height; y++ ) {
		u8* pd = data + y * width;
		u8* pr = raw + (height - y - 1) * w;
		for ( int x = 0; x < width; x++ ) {
			pd[x] = pr[x];
		}
	}
	free(raw);
	fclose( fp );

	return data;
}

void loadSprite( char* filename, int mode ) {
	int i;
	int width;
	int height;

	switch (mode) {
	case SPRITE_MODE_8x8:
		height = 8;
		width = 8;
		break;
	case SPRITE_MODE_16x8:
		height = 8;
		width = 16;
		break;
	case SPRITE_MODE_8x16:
		height = 16;
		width = 8;
		break;
		
	case SPRITE_MODE_16x16:
		height = 16;
		width = 16;
		break;
	case SPRITE_MODE_32x8:
		height = 8;
		width = 32;
		break;
	case SPRITE_MODE_8x32:
		height = 32;
		width = 8;
		break;
		
	case SPRITE_MODE_32x32:
		height = 32;
		width = 32;
		break;
	case SPRITE_MODE_32x16:
		height = 16;
		width = 32;
		break;
	case SPRITE_MODE_16x32:
		height = 32;
		width = 16;
		break;
		
	case SPRITE_MODE_64x64:
		height = 64;
		width = 64;
		break;
	case SPRITE_MODE_64x32:
		height = 32;
		width = 64;
		break;
	case SPRITE_MODE_32x64:
		height = 64;
		width = 32;
		break;
	default:
		throw HSPERR_INVALID_PARAMETER;
	}

	u32 biWidth, biHeight;
	u8* bmp = loadBmp( filename, biWidth, biHeight, SPRITE_PALETTE );

	if ( bmp == NULL ) {
		printf("failed to open bmp file %s\n", filename);
		throw HSPERR_FILE_IO;
	}

	int tx = biWidth / width;
	int ty = biHeight / height;

	spriteTiles = (u16*)malloc(biWidth * biHeight);

	u8* vd = (u8*)spriteTiles;
	for (int sy = 0; sy < ty; sy++) {
		for (int sx = 0; sx < tx; sx++) {
			for (int y = 0; y < height >> 3; y++) {
				for (int x = 0; x < width >> 3; x++) {
					for(int iy = 0; iy < 8; iy++) {
						u8* d = bmp + ((x << 3) + sx * width
										 + biWidth * (iy + (y << 3) + sy * height));
						for(int ix = 0; ix < 8; ix++) {
							*(vd++) = d[ix];
						}
					}
				}
			}
		}
	}

	spriteShape = (mode & 0x0f00) << 6;
	spriteSize = (mode & 0x0f) << 14;
	
	tilesPerSprite = (width >> 3) * (height >> 3) * 2;
}

void loadTile( char* filename ) {
	int i;

	u32 biWidth, biHeight;
	u8* bmp = loadBmp( filename, biWidth, biHeight, BG_PALETTE );

	if ( bmp == NULL ) {
		printf("failed to open file %s\n", filename);
		throw HSPERR_FILE_IO;
	}

	int tx = biWidth / 8;
	int ty = biHeight / 8;

	mapTiles = (u16*)malloc(biWidth * biHeight);

	u8* vd = (u8*)mapTiles;

	for (int sy = 0; sy < ty; sy++) {
		for (int sx = 0; sx < tx; sx++) {
			for(int iy = 0; iy < 8; iy++) {
				u8* d = bmp + (sx * 8
							   + biWidth * (iy + sy * 8));
				for(int ix = 0; ix < 8; ix++) {
					*(vd++) = d[ix];
				}
			}
		}
	}

#if 0
	printf("extend file to memory\n");
	for (int i = 0; i < 60; i++)
		swiWaitForVBlank();

	u16* map;

	videoSetMode(MODE_0_2D | DISPLAY_BG3_ACTIVE | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D | DISPLAY_SPR_1D_BMP);

	BG3_CR = BG_64x64 | BG_COLOR_256 | BG_MAP_BASE(0) | BG_TILE_BASE(1) | BG_PRIORITY_3;

	map = (u16*)BG_MAP_RAM(0);
//	for (int ly = 0; ly < 2; ly ++) {
	{int ly = 0;
//		for (int lx = 0; lx < 2; lx++) {
		{int lx = 0;
			for (int y = 0; y < 32; y++) {
				for (int x = 0; x < 32; x++) {
					if (lx == 0 && ly == 0) {
						int id = lx * 32 + x  + (ly * 32 + y) * 60;
						int n = useTile(id, 0);
						map[(lx + ly * 2) * 32 * 32 + (y * 32 + x)] = n;
					}
				}
			}
		}
	}

	printf("init bg3\n");
	for (int i = 0; i < 60; i++)
		swiWaitForVBlank();

	videoSetMode(MODE_0_2D | DISPLAY_BG2_ACTIVE | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D | DISPLAY_SPR_1D_BMP);

	BG2_CR = BG_64x64 | BG_COLOR_256 | BG_MAP_BASE(3) | BG_TILE_BASE(5) | BG_PRIORITY_2;

	map = (u16*)BG_MAP_RAM(3);
//	for (int ly = 0; ly < 2; ly ++) {
	{int ly = 0;
//		for (int lx = 0; lx < 2; lx++) {
		{int lx = 0;
			for (int y = 0; y < 32; y++) {
				for (int x = 0; x < 32; x++) {
					if (lx == 0 && ly == 0) {
						int id = lx * 32 + (x + 18 * 2)  + (ly * 32 + (y + 8 * 2)) * 60;
						int n = useTile(id, 1);
						if (n >= 0) {
							map[(lx + ly * 2) * 32 * 32 + (y * 32 + x)] = n;
						} else {
							printf("no more space\n");
						}
					}
				}
			}
		}
	}
	printf("init bg2\n");
	for (int i = 0; i < 60; i++)
		swiWaitForVBlank();

	videoSetMode(MODE_0_2D | DISPLAY_BG2_ACTIVE | DISPLAY_BG3_ACTIVE | DISPLAY_SPR_ACTIVE | DISPLAY_SPR_1D | DISPLAY_SPR_1D_BMP);
	for (int i = 0; i < 60; i++)
		swiWaitForVBlank();
#endif
}

void hsp3typeinit_cl_extfunc( HSP3TYPEINFO *info )
{
	info->reffunc = reffunc_function;
}

int useSprite( int id ) {
	int endTile = MAX_SPRITE / tilesPerSprite;
	unsigned int now = GetTickCount();
	unsigned int lastUsed = 0xffffffff;
	int least = -1;
	for (int i = 0; i < endTile; i++) {
		if (sprites[i].id == id) {
			sprites[i].used ++;
			sprites[i].lastUsed = now;
			return i;
		}
		if (sprites[i].used == 0 && sprites[i].lastUsed < lastUsed) {
			least = i;
			lastUsed = sprites[i].lastUsed;
		}
	}
	if (least >= 0) {
		sprites[least].id = id;
		sprites[least].used ++;
		sprites[least].lastUsed = now;

		u16* vram = SPRITE_GFX + tilesPerSprite * least * 16;
		u16* bitmap = spriteTiles + tilesPerSprite * id * 16;

		for (int i = 0; i < tilesPerSprite * 16; i++ ) {
			vram[i] = bitmap[i];
		}

		return least;
	} else {
		throw HSPERR_UNSUPPORTED_FUNCTION;
	}
}

void releaseSprite( int tileIdx ) {
	int tile = tileIdx / tilesPerSprite;
	if (sprites[tile].id >= 0) {
		sprites[tile].lastUsed = GetTickCount();
		sprites[tile].used --;
	}
}

int useTile( int id, int no ) {
	unsigned int now = GetTickCount();
	unsigned int lastUsed = 0xffffffff;
	int least = -1;
	int ofs = no * MAX_MAP;
	int ofsId = no * MAX_MAP_ID;
	
	if (mapId[id + ofsId] != 0xffff) {
		int i = mapId[id + ofsId];
		if (maps[i].id != id)
			throw HSPERR_UNKNOWN_CODE;
		maps[i].used ++;
		maps[i].lastUsed = now;
		return i - ofs;
	}
	for (int i = ofs; i < MAX_MAP + ofs; i++) {
		if (maps[i].used == 0 && maps[i].lastUsed < lastUsed) {
			least = i;
			lastUsed = maps[i].lastUsed;
		}
	}
	if (least >= 0) {
		maps[least].id = id;
		maps[least].used ++;
		maps[least].lastUsed = now;

		u16* vram = (u16*)BG_TILE_RAM(no * 4 + 1) + (least - ofs) * 32;
		u16* bitmap = mapTiles + id * 32;

		for (int i = 0; i < 32; i++ ) {
			vram[i] = bitmap[i];
		}
		mapId[id + ofsId] = least;
		return least - ofs;
	} else {
		return -1;
	}
}

void releaseTile( int tile, int no ) {
	int ofs = no * MAX_MAP;
	if (maps[tile].id >= 0) {
		maps[tile].lastUsed = GetTickCount();
		maps[tile].used --;
	}
}
